<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑分销商资金明细表' : '添加分销商资金明细表'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="分销商用户ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入分销商用户ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="订单ID" name="orderId">
        <a-input
          allow-clear
          placeholder="请输入订单ID"
          v-model:value="form.orderId"
        />
      </a-form-item>
      <a-form-item label="资金流动类型 (10佣金收入 20提现支出 30转账支出 40转账收入)" name="flowType">
        <a-input
          allow-clear
          placeholder="请输入资金流动类型 (10佣金收入 20提现支出 30转账支出 40转账收入)"
          v-model:value="form.flowType"
        />
      </a-form-item>
      <a-form-item label="金额" name="money">
        <a-input
          allow-clear
          placeholder="请输入金额"
          v-model:value="form.money"
        />
      </a-form-item>
      <a-form-item label="描述" name="describe">
        <a-input
          allow-clear
          placeholder="请输入描述"
          v-model:value="form.describe"
        />
      </a-form-item>
      <a-form-item label="对方用户ID" name="toUserId">
        <a-input
          allow-clear
          placeholder="请输入对方用户ID"
          v-model:value="form.toUserId"
        />
      </a-form-item>
      <a-form-item label="修改时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入修改时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addDealerCapital, updateDealerCapital } from '@/api/shop/dealerCapital';
  import { DealerCapital } from '@/api/shop/dealerCapital/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: DealerCapital | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<DealerCapital>({
    id: undefined,
    userId: undefined,
    orderId: undefined,
    flowType: undefined,
    money: undefined,
    describe: undefined,
    toUserId: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    dealerCapitalId: undefined,
    dealerCapitalName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    dealerCapitalName: [
      {
        required: true,
        type: 'string',
        message: '请填写分销商资金明细表名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateDealerCapital : addDealerCapital;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
